#ifndef _TRIE_H
#define _TRIE_H

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

extern int line_size;

#define INS_INC(x)

#define ThreshHold 8
#define MaxTnSize 29
#define MaxWordLen 32
#define MaxDataLen 100

enum Boolean {False, True};

void nullprintf(FILE * fp, char *string, ...);

typedef char *dataType;

class TrieNode {
  char size;	// actual size for trie node
  char space;	// actual space for key and data buffer
  char *pattern;
  TrieNode **next;
  dataType *data;

  friend class Trie;

 public:
  TrieNode(int tns) {
    /*
    for (int i=0; i<PatternSize; i++) 
      pattern[i]=-1;
      */
    size=0;
    space=tns;
#if 0
    pattern=new char[tns];
    next=new (TrieNode*)[tns];
#else
   if (line_size >= tns*(sizeof(char)+sizeof(TrieNode *))+sizeof(TrieNode *)) {
     pattern= (char *) malloc(tns*(sizeof(char)+sizeof(TrieNode *))+sizeof(TrieNode *));
     next=(TrieNode **)(pattern+ (tns/sizeof(TrieNode *)+1)*sizeof(TrieNode *));
   }
   else {
    pattern=new char[tns];
    next=new (TrieNode*)[tns];
   }
#endif   

    data=new dataType[tns];
  }

  int Insert(char);
  int Search(char);
};

class Trie {
  TrieNode* root;
  int tnsize;
  TrieNode* tnList[MaxWordLen];	// used for traversal
  int index[MaxWordLen];
  int depth;

 public:
  Trie(int s) {
    tnsize=s;
    root=NULL;
  }

  Boolean Insert(char*, dataType);
  dataType Search(char*);
  void print_word(FILE*);
  void Dump(FILE*);
};

#endif
